package esercizio2;

public class Azienda {
	
	public static final int MAX_DIPENDENTI = 200;
	public static final int MAX_BUSTE_PAGA = 2500;
	
	
	private Dipendente[] personale;
	private int numDipendenti;
	private BustaPaga[] bustePaga;
	private int numBustePaga;
	
	public Azienda() {
		this(new Dipendente[MAX_DIPENDENTI], 0, new BustaPaga[MAX_BUSTE_PAGA], 0);
		
	}
	
	public Azienda(Dipendente[] personale, int numD, BustaPaga[] bustePaga, int numB) {
		this.personale = personale;
		this.numDipendenti = numD;
		this.bustePaga = bustePaga;
		this.numBustePaga = numB;
	}
	
	
	
	public int getNumDipendenti() {
		return numDipendenti;
	}

	public void setNumDipendenti(int numD) {
		this.numDipendenti = numD;
	}

	public int getNumBustePaga() {
		return numBustePaga;
	}

	public Dipendente[] getPersonale() {
		return personale;
	}
	
	public void setPersonale(Dipendente[] personale) {
		this.personale = personale;
	}

	public BustaPaga[] getBustePaga() {
		return bustePaga;
	}
	
	/*
	 * Metodo per l'inserimento di una busta paga nell'array,
	 * Viene invocato solo dal metodo giornoDiPaga, quindi potrebbe essere privato
	 */
	public void inserisciBustaPaga(BustaPaga b)
	{
		if(numBustePaga < MAX_BUSTE_PAGA ) {
			bustePaga[numBustePaga] = b;
			numBustePaga ++;
		}else
			System.out.println("Errore: impossibile inserire la busta paga.\n");
	}
	
	public void giornoDiPaga(String data){
		/*
		 * Per ogni elemento dell'array personale, 
		 * creo una nuova busta paga, la inserisco nell'array e la stampo
		 */
		for(int i=0;i<numDipendenti;i++){
			System.out.println("-----------------\n"+personale[i].getNome() + ": ");
			BustaPaga b = new BustaPaga(personale[i], data);
			inserisciBustaPaga(b);
			System.out.println(b);
			
		}
	}
}
